import websocket
import json
import hashlib
import random

serverUrl = "ws://192.168.5.244/rpc";
username = "bob"
password = "hello"

def on_message(ws, message):
    handled = False
    msg = json.loads(message)
    msgid = msg["id"]
    if "error" in msg:
        error = msg["error"]
        hint = json.loads(error["message"])
	if error["code"] == 401:
            if msgid == 123:
	        method = "FS.List"
            respmsg = {
                "id": msgid,
                "method": method,
                "auth": dodigest(hint, username, password)
            }
            ws.send(json.dumps(respmsg))
	    handled = True
    elif "result" in msg:
        if msgid == 123:
            print("Listing:\n\t" + json.dumps(msg["result"]) + "\n")
            handled = True
    if handled == False:
        print(message)


def on_error(ws, error):
    print(error)

def on_close(ws):
    print("### closed ###")

def on_open(ws):
    # method needs to be recalled later on error response
    msg = {
        "id": 123,
        "method": "FS.List",
    }
    ws.send(json.dumps(msg))


def dodigest(hint, user, pwd):
    realm = hint["realm"]
    nonce = hint["nonce"]
    nc = hint["nc"]
    cnonce = str(random.randint(0, (2**64-1)))
    str1 = user + ":" + realm + ":" + pwd
    ha1 = hashlib.md5(str1.encode())
    str2 = "dummy_method:dummy_uri"
    ha2 = hashlib.md5(str2.encode())
    rstr = ha1.hexdigest() + ":" + str(nonce) + ":" + str(nc) + ":" + cnonce + ":auth:" + ha2.hexdigest()
    response = hashlib.md5(rstr.encode())
    respmsg = {
        "realm": realm,
        "username": user,
        "nonce": nonce,
        "cnonce": cnonce,
        "response": response.hexdigest()
    }
    return respmsg


if __name__ == "__main__":
#    websocket.enableTrace(True)
    ws = websocket.WebSocketApp(serverUrl,
                              on_message = on_message,
                              on_error = on_error,
                              on_close = on_close)
    ws.on_open = on_open
    ws.run_forever()
