import websocket
import json

serverUrl = "ws://192.168.5.244/rpc";

def on_message(ws, message):
    msg = json.loads(message)
    if msg["id"] == 123:
        print("WiFi config is:\n\t" + json.dumps(msg["result"]) + "\n")
    elif msg["id"] == 456:
        print("System info:\n\t" + json.dumps(msg["result"]) + "\n")
    else:
        print(message)


def on_error(ws, error):
    print(error)

def on_close(ws):
    print("### closed ###")

def on_open(ws):
    do0();
    do1();

def do1():
    msg = {
        "id": 123,
        "method": "Config.Get",
        "params": {"key": "wifi.sta"}
    }
    ws.send(json.dumps(msg))

def do0():
    msg = {
        "id": 456,
        "method": "Sys.GetInfo"
    }
    ws.send(json.dumps(msg))


if __name__ == "__main__":
    websocket.enableTrace(True)
    ws = websocket.WebSocketApp(serverUrl,
                              on_message = on_message,
                              on_error = on_error,
                              on_close = on_close)
    ws.on_open = on_open
    ws.run_forever()
